// ITERATOR.H -  Iterator

#if !defined (__ITERATOR_H)
#define  __ITERATOR_H

#if !defined (__LINK_H)
#include "LINK.H"
#endif

#include <mem.h>
#include <assert.h>

template<class T>
class Iterator
{
public:
 Iterator() : position(NULL), last(NULL) { }      // 
 T operator*() const;                             //   
 void operator++();                               //    
 void operator++(int);                           //    
 void operator--();                               // -   
 void operator--(int);                            // -   
 int operator !=(Iterator b) const { return position != b.position; } //  !=
 int operator ==(Iterator b) const { return position == b.position; }  // now ==
private:
 Link<T> *position;                               //    
 Link<T> *last;                                   //    
friend class List<T>;                             // List    
};

template<class T>
T Iterator<T>::operator *() const
{ //          
 assert(position != NULL);
   return position->data;
}

template<class T>
void Iterator<T>::operator ++(int)
{ //    
 assert(position != NULL);
  position = position->next;
}

template<class T>
void Iterator<T>::operator --(int)
{ //     
 if (!position)                 //       ?
 position = last;               //  -->     
 else                           // 
 position = position->previous; //    
   assert(position != NULL);    //      
}

#endif // __ITERATOR_H
